/**
 * Freqtrade API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2021.12-dev21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import AnyOfnumberstring from './AnyOfnumberstring';

/**
 * The BacktestRequest model module.
 * @module model/BacktestRequest
 * @version 2021.12-dev21
 */
class BacktestRequest {
    /**
     * Constructs a new <code>BacktestRequest</code>.
     * @alias module:model/BacktestRequest
     * @param strategy {String} 
     * @param enableProtections {Boolean} 
     */
    constructor(strategy, enableProtections) { 
        
        BacktestRequest.initialize(this, strategy, enableProtections);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj, strategy, enableProtections) { 
        obj['strategy'] = strategy;
        obj['enable_protections'] = enableProtections;
    }

    /**
     * Constructs a <code>BacktestRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/BacktestRequest} obj Optional instance to populate.
     * @return {module:model/BacktestRequest} The populated <code>BacktestRequest</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new BacktestRequest();

            if (data.hasOwnProperty('strategy')) {
                obj['strategy'] = ApiClient.convertToType(data['strategy'], 'String');
            }
            if (data.hasOwnProperty('timeframe')) {
                obj['timeframe'] = ApiClient.convertToType(data['timeframe'], 'String');
            }
            if (data.hasOwnProperty('timeframe_detail')) {
                obj['timeframe_detail'] = ApiClient.convertToType(data['timeframe_detail'], 'String');
            }
            if (data.hasOwnProperty('timerange')) {
                obj['timerange'] = ApiClient.convertToType(data['timerange'], 'String');
            }
            if (data.hasOwnProperty('max_open_trades')) {
                obj['max_open_trades'] = ApiClient.convertToType(data['max_open_trades'], 'Number');
            }
            if (data.hasOwnProperty('stake_amount')) {
                obj['stake_amount'] = ApiClient.convertToType(data['stake_amount'], AnyOfnumberstring);
            }
            if (data.hasOwnProperty('enable_protections')) {
                obj['enable_protections'] = ApiClient.convertToType(data['enable_protections'], 'Boolean');
            }
            if (data.hasOwnProperty('dry_run_wallet')) {
                obj['dry_run_wallet'] = ApiClient.convertToType(data['dry_run_wallet'], 'Number');
            }
        }
        return obj;
    }


}

/**
 * @member {String} strategy
 */
BacktestRequest.prototype['strategy'] = undefined;

/**
 * @member {String} timeframe
 */
BacktestRequest.prototype['timeframe'] = undefined;

/**
 * @member {String} timeframe_detail
 */
BacktestRequest.prototype['timeframe_detail'] = undefined;

/**
 * @member {String} timerange
 */
BacktestRequest.prototype['timerange'] = undefined;

/**
 * @member {Number} max_open_trades
 */
BacktestRequest.prototype['max_open_trades'] = undefined;

/**
 * @member {module:model/AnyOfnumberstring} stake_amount
 */
BacktestRequest.prototype['stake_amount'] = undefined;

/**
 * @member {Boolean} enable_protections
 */
BacktestRequest.prototype['enable_protections'] = undefined;

/**
 * @member {Number} dry_run_wallet
 */
BacktestRequest.prototype['dry_run_wallet'] = undefined;






export default BacktestRequest;

